package com.offcn.api.nwn.service;


import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;



/**
 *  判断用户是否购买课件_通过层级ID
 * 
 * @author liyy
 *
 */
public class checkVideoUrlByID extends NWN implements API {
	
	public String parameter;//参数集合
	
	public String phone;//

	public String  package_id;
	public String sso_id;//
	public String user_id;
	public int video_id;
	@Override
	public void initialize(HashMap<String, Object> data) {
		try {
			String sql="SELECT id ,sso_id FROM  n_user ORDER BY id DESC LIMIT 1";
			//SELECT  id FROM  n_template ORDER BY id DESC LIMIT 1
			ResultSet rs_bankcard = this.sqlFromDB(sql);
			rs_bankcard.last();
			sso_id = rs_bankcard.getString("sso_id");
			user_id = rs_bankcard.getString("id");
			
		} catch (Exception e) {
			
			e.printStackTrace();
		}
			
		try {
			String sql="SELECT package_id  FROM  nwn_pack.n_user_package_"+(Integer.parseInt(user_id)%100)+" where user_id=" + user_id;
			//SELECT  id FROM  n_template ORDER BY id DESC LIMIT 1
		//	System.out.println("sql===" + sql);
			ResultSet rs_bankcard = this.sqlFromDB_package(sql);
			rs_bankcard.last();
			package_id = rs_bankcard.getString("package_id");
			//System.out.println("package_id=== "+ package_id);
			//System.out.println("n_package_idList=== "+ n_package_idList.get(0));
			if (package_id.equals(n_package_idList.get(0))) {
				System.out.println("successful");
			}else {
				System.out.println("fail");
			}
			
						
		} catch (Exception e) {
			
			e.printStackTrace();
		}
	}
	
	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		package_id = MapUtil.getParameter_get(parameter, "package_id").trim();
		String sso_id_p = MapUtil.getParameter_get(parameter, "sso_id").trim();
		String video_id_p = MapUtil.getParameter_get(parameter, "video_id").trim();
		if ((!package_id.equals("")) && package_id.equals("package_id")) {
		    package_id=ListUtil.getListValue(n_package_idList, 0);
		    parameter = parameter.replace("package_id=package_id", "package_id="+ package_id );
		}
		if ((!sso_id_p.equals("")) && sso_id_p.equals("sso_id")) {
			
		    parameter = parameter.replace("sso_id=sso_id", "sso_id="+ sso_id );
		}
		
		if ((!video_id_p.equals("")) && video_id_p.equals("video_id")) {
			
		    parameter = parameter.replace("video_id=video_id", "video_id="+ video_id );
		}	
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
//		Map<String,String> m=new HashMap<String,String>();
//		m.put("user_info", parameter);
		//Response re = RequestDataUtils.Post_cooike_form_data(data, Url,"PHPSESSID",PHPSESSID,m);	
		//Response re = RequestDataUtils.Get_one_cookie_pre(data, Url, "PHPSESSID",PHPSESSID);
		//parameter = MapUtil.getValue("parameter", data);
		
		Map<String,String> cookies=new HashMap<String,String>();
		cookies.put("PHPSESSID", PHPSESSID);
		/*Map<String,String> token=new HashMap<String,String>();
		token.put("Authorization", tk_token);*/

		MyRequest myRequest=new MyRequest();
		myRequest.setParameter(parameter);
		myRequest.setUrl(Url);
		myRequest.setRequest(Request);
		myRequest.setCookies(cookies);
		
		Response re = RequestDataUtils.RestAssuredApi(data, myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		System.out.println( "jp===="+ jp);
		boolean result = true;
		String failReason = "";

		String json = re.asString();
		System.out.println("response=========="+StringUtils.decodeUnicode(json));

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(getMsg(re));
			String code=getCode(re);
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}

			/*System.out.println((data.get("msg") != null));
			System.out.println((msg != null));
			System.out.println(data.get("msg").toString().length());
			System.out.println(msg.length());
			*/
			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					System.out.println(strCustomStrings.length);
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			
			
			if("0".equals(code)){
				
				//创建后数据库在哪个表
				//是否验证数据库
				if (!isProduct) {
					
					/*template_id=jp.getString("data.id").substring(0,jp.getString("data.id").length());
					
					System.out.println("template_id====="+ template_id );
					try {
						String sql="SELECT  deleted_at  FROM `n_package`  WHERE  id =  " + package_id;
						//SELECT  id FROM  n_template ORDER BY id DESC LIMIT 1
						ResultSet rs_bankcard = this.sqlFromDB(sql);
						rs_bankcard.last();
						System.out.println("after deleted_packate ============"+ rs_bankcard.getString("deleted_at"));
						if(rs_bankcard.getString("deleted_at").contains("2019") )
						{
							
							
						}else {
							result = result && false;
							failReason = failReason + "deleted_packate  is wrong;";
						}
						
						
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify template_id info in DB;";
						e.printStackTrace();
					}*/
				}
			
			
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
