package com.offcn.api.nwn.service;


import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;

import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;



/**
 * 删除班级(教务包)
 * 
 * @author liyy
 *
 */
public class delEduPackage extends NWN implements API {
	
	public String parameter;//参数集合
	
	public String template_id_1;//母板ID
	public String  package_id;
	public String  del_package_id;
//	public String phone;//层级包id
	@Override
	public void initialize(HashMap<String, Object> data) {
		
		try {
			String sql="SELECT  MAX(id) AS id  FROM `n_package`  WHERE  deleted_at IS NOT NULL ";
	
			ResultSet rs_bankcard = this.sqlFromDB(sql);
			rs_bankcard.last();
			
			del_package_id = rs_bankcard.getString("id");
			System.out.println("del_package_id====" + del_package_id);
		} catch (Exception e) {
			
			e.printStackTrace();
		}
		
		
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		template_id_1 = MapUtil.getParameter_get(parameter, "template_id").trim();
		timestamp = MapUtil.getParameter_get(parameter, "timestamp").trim();
		package_id = MapUtil.getParameter_get(parameter, "package_id").trim();
		if ((!template_id_1.equals("")) && template_id_1.equals("template_id")) {
			template_id_1 =  template_id;
			parameter = parameter.replace("template_id=template_id", "template_id="+ template_id_1 );
		}
		if ((!package_id.equals("")) && package_id.equals("package_id")) {
			package_id=ListUtil.getListValue(n_package_idList, 0);
			parameter = parameter.replace("package_id=package_id", "package_id="+ package_id );
		}
		if ((!package_id.equals("")) && package_id.equals("del_package_id")) {
			
			parameter = parameter.replace("package_id=del_package_id", "package_id="+ del_package_id );
		}
		
		if ((!timestamp.equals("")) && timestamp.equals("timestamp")) {
			Long timeString= System.currentTimeMillis();
			timestamp = timeString.toString().substring(0, 10);
			parameter = parameter.replace("timestamp=timestamp", "timestamp="+ timestamp );
		}
				
		
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
//		Map<String,String> m=new HashMap<String,String>();
//		m.put("user_info", parameter);
		//Response re = RequestDataUtils.Post_cooike_form_data(data, Url,"PHPSESSID",PHPSESSID,m);	
		Response re = RequestDataUtils.Get_one_cookie_pre(data, Url, "PHPSESSID",PHPSESSID);
		//Response re = RequestDataUtils.Get_one_cookie(data, serviceURL, cookie1Name, cookie1value)   //只能无参
//		Response re = RequestDataUtils.Get_token(data, Url, "");
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		System.out.println( "jp===="+ jp);
		boolean result = true;
		String failReason = "";

		String json = re.asString();
		System.out.println("response=========="+StringUtils.decodeUnicode(json));

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(getMsg(re));
			String code=getCode(re);
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}

			/*System.out.println((data.get("msg") != null));
			System.out.println((msg != null));
			System.out.println(data.get("msg").toString().length());
			System.out.println(msg.length());
			*/
			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					System.out.println(strCustomStrings.length);
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			
			
			if("0".equals(code)){
				
				//创建后数据库在哪个表
				//是否验证数据库
				if (!isProduct) {
					
					/*template_id=jp.getString("data.id").substring(0,jp.getString("data.id").length());
					
					System.out.println("template_id====="+ template_id );*/
					try {
						String sql="SELECT  deleted_at  FROM `n_package`  WHERE  id =  " + del_package_id;
					
						ResultSet rs_bankcard = this.sqlFromDB(sql);
						rs_bankcard.last();
						System.out.println("after deleted_packate ============"+ rs_bankcard.getString("deleted_at"));
						if(rs_bankcard.getString("deleted_at").contains("2019") )
						{
							
							
						}else {
							result = result && false;
							failReason = failReason + "deleted_packate  is wrong;";
						}
						
						
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify template_id info in DB;";
						e.printStackTrace();
					}
				}
			
			
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
